// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "ProceduralPlanet.h"
#include "GameFramework/Actor.h"
#include "TerrainChunk.generated.h"

class URuntimeMeshComponent;
class UProceduralMeshComponent;

UCLASS()
class PROCPLANET_API ATerrainChunk : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	ATerrainChunk();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	void InitQuadTree(AProceduralPlanet* PlanetActor, int32 ChunkDepth);
	void InitMesh(int32 Resolution, FVector Offset, float Radius);

private:
	UPROPERTY()
	UProceduralMeshComponent* ProcMeshComp;
	UPROPERTY()
	AProceduralPlanet* Planet;
	
	//QuadTree
	UPROPERTY()
	ATerrainChunk* Parent;
	TArray<ATerrainChunk> Children;
	int32 Depth = 0;
	int32 ChunkResolution = 0;
	UPROPERTY()
	float ChunkRadius = 0.0;
	UPROPERTY()
	float DistanceToSplit;
	UPROPERTY()
	float DistanceToJoin;

	UFUNCTION(BlueprintCallable, CallInEditor)
	void Update();
	
	UFUNCTION(BlueprintCallable, CallInEditor)
	void Split();
	UFUNCTION(BlueprintCallable, CallInEditor)
	void UnSplit();
};
