// Fill out your copyright notice in the Description page of Project Settings.

#include "ProceduralPlanet.h"
#include "KismetProceduralMeshLibrary.h"
#include "Kismet/GameplayStatics.h"
#include "ProcPlanet/Actors/TerrainChunk.h"

// Sets default values
AProceduralPlanet::AProceduralPlanet()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = false;
}

void AProceduralPlanet::OnConstruction(const FTransform& Transform)
{
	MaxResolution = ChunkMinResolution * FMath::Pow(static_cast<float>(ChunkResolutionIncreasePerLodLevel), static_cast<float>(ChunkLodLevels));
	
	// Cleanup previous
	TArray<AActor*> TerrainChunks;
	UGameplayStatics::GetAllActorsOfClass(this, ATerrainChunk::StaticClass(), TerrainChunks);
	for(AActor* TerrainChunk : TerrainChunks) {
		TerrainChunk->Destroy();
	}

	ATerrainChunk* Chunk = GetWorld()->SpawnActor<ATerrainChunk>();

	Chunk->InitQuadTree(this, 0);
	Chunk->InitMesh(ChunkMinResolution, FVector(0,0,0), Radius);
}

// Called when the game starts or when spawned
void AProceduralPlanet::BeginPlay()
{
	Super::BeginPlay();
}

// Called every frame
void AProceduralPlanet::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}
