// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "ProceduralMeshComponent.h"
#include "GameFramework/Actor.h"
#include "ProceduralPlanet.generated.h"

UCLASS()
class PROCPLANET_API AProceduralPlanet : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AProceduralPlanet();

	virtual void OnConstruction(const FTransform& Transform) override;
	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	UPROPERTY(EditAnywhere, Category="Config")
	float Radius = 512.0f;
	
	UPROPERTY(EditAnywhere, Category="Config")
	AActor* ChunkDistanceActor;
	UPROPERTY(EditAnywhere, Category="Config")
	int32 ChunkMinResolution = 8;
	UPROPERTY(EditAnywhere, Category="Config")
	int32 ChunkLodLevels = 6;
	UPROPERTY(EditAnywhere, Category="Config")
	int32 ChunkResolutionIncreasePerLodLevel = 2;

	UPROPERTY(VisibleAnywhere, Category="Config")
	int32 MaxResolution = 0;
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

private:
		
	TArray<FVector> Vertices;
	TArray<FVector> Normals;
	TArray<int32> Triangles;
	TArray<FVector2D> UVs;
	TArray<FLinearColor> VertexColors;
	TArray<FProcMeshTangent> Tangents;

};
